package functionaljavatest;

import fj.Effect;
import fj.F2;
import fj.F;
import fj.data.Array;
import fj.function.Integers;
import static fj.data.Array.*;

import static fj.Show.arrayShow;
import static fj.Show.intShow;

/**
 *
 * @author ubik
 */
public class ArrayTest {

    public static void main(String[] args) {
        Array<Integer> a = array(19, 412, 319, 55, 10, 95, 23, 97, 192, 84, 82, 331, 5);

        // Calc min
        int min = a.foldLeft(new F2<Integer, Integer, Integer>() {

            @Override
            public Integer f(Integer a, Integer b) {
                return a < b ? a : b;
            }
        }, Integer.MAX_VALUE);
        System.out.println("Min value " + min);

        // Calc sum
        int sum = a.foldLeft(Integers.add, 0);
        System.out.println("Sum value " + sum);

        // Extract even numbers
        Array<Integer> b = a.filter(Integers.even);
        arrayShow(intShow).println(b);

        // Chaining
        sum = a.filter(Integers.even).foldLeft(Integers.add, 0);
        System.out.println("Sum of even numbers " + sum);
    }
}
